clear all 
close all
%-------------------------------------------
% Das Pohlsche Rad: Periodenverdopplungen und Chaos mit dem klassischen RK4
% Verfahren.
%
%  J*x''+K*x'+D*x-N*sin(x)=F*sin(omega*t)
%
%  System vom GDGl:
%   x'=y
%   y'=-a*y-d*x+c*sin(x)+d*sin(omega*z)
%   z'=1
%
% a=K/J=0.799; b=D/J=9.44; c=N/J=14.68; d=F/J=2.1
%
% (a) omega=2.5, (b) omega=2.32, (c) omega=2.3, (d) omega=2.25
%
%-----------------------------------------------
global a b c d omega
a=0.799; 
b=9.44; 
c=14.68; 
d=2.1;
Tend=300; % (a) Tend=80, (b) Tend=150, (c) Tend=150, (d) Tend=300
x0=0;
y0=0;
h=0.005;
M=Tend/h;
%---------- omega=[2.5,2.25]-----------------------
omega=2.25;
figure(1)
R1=rk4s('prx','pry',0,Tend,x0,y0,h);
plot(R1(:,2),R1(:,3),'r')
figure(2)
plot(R1(M/2:M+1,2),R1(M/2:M+1,3),'r')
xlabel('\phi','FontName','Times New Roman','FontSize',16)
ylabel('d\phi/dt','FontName','Times New Roman','FontSize',16)
figure(3)
plot(R1(:,1),R1(:,2),'b')
xlabel('t','FontName','Times New Roman','FontSize',16)
ylabel('\phi','FontName','Times New Roman','FontSize',16)
%------------return map------------------------
t=R1(:,1);
x=R1(:,2);
y=R1(:,3);
k=1;
figure(4)
plot(R1(:,1),R1(:,2),'b')
hold on
xlabel('t','FontName','Times New Roman','FontSize',16)
ylabel('\phi','FontName','Times New Roman','FontSize',16)
for i=M/2:M-2
    if ((x(i+1)>x(i)) && (x(i+2)<x(i+1)))
        mt(k)=t(i+1);
        mx(k)=x(i+1);
        k=k+1;
    end;
end;
for i=1:size(mx,2)-1
    plot(mt,mx,'ro','MarkerEdgeColor','r',...
                'MarkerFaceColor','g',...
                'MarkerSize',5);
    hold on
end;
figure(6)
for i=1:size(mx,2)-1
    plot(mx(i),mx(i+1),'ro','MarkerEdgeColor','r',...
                'MarkerFaceColor','g',...
                'MarkerSize',5);
           axis([min(mx)-0.1 max(mx)+0.1 min(mx)-0.1 max(mx)+0.1])
    hold on
end;
xlabel('\phi_n','FontName','Times New Roman','FontSize',16)
ylabel('\phi_{n+1}','FontName','Times New Roman','FontSize',16)
