clear all 
close all
%-------------------------------------------
% Lorenz Gleichungen: "Strange attractor" mit dem klassischen RK4
% Verfahren.
%
%       x'=sigma*(y-x); 
%       y'=r*x-y-x*z;
%       z'=x*y-b*z; 
%
%     x(0)=0, y(0)=1, z(0)=0;
%
%   sigma=10, b=8/3, rh=24.74; h=0.005; Tend=20;
%
%   (a) r=0.5;  (b) r=3; (c) r=16; (d) r=25 (e) r=145-148 (f) r=210-234
%-----------------------------------------------
global sigma b r
sigma=10;
b=8/3;
Tend=30; % 
x0=0;
y0=1;
z0=0;
h=0.005;
M=Tend/h;
tt=10;
%--------------r=[0, 30]-----------------------
r=27;
R1=rk4s3('lorx','lory','lorz',0,Tend,x0,y0,z0,h);
R2=rk4s3('lorx','lory','lorz',0,Tend,x0+0.05,y0+0.05,z0+0.05,h);
% %-----------------
figure(1)
plot(R1(:,1),R1(:,4),'b')
xlabel('t','FontName','Times New Roman','FontSize',16)
ylabel('z','FontName','Times New Roman','FontSize',16)
%-----------------
figure(2)
plot(R1(:,1),R1(:,2),'b')
xlabel('t','FontName','Times New Roman','FontSize',16)
ylabel('x','FontName','Times New Roman','FontSize',16)
%-----------------
figure(3)
plot3(R1(:,2),R1(:,3),R1(:,4),'b')
grid on 
view([6.0 14.0])
xlabel('x','FontName','Times New Roman','FontSize',16)
ylabel('y','FontName','Times New Roman','FontSize',16)
zlabel('z','FontName','Times New Roman','FontSize',16)
%-----------------Lorenz map-----------------
t=R1(:,1);
x=R1(:,2);
y=R1(:,3);
z=R1(:,4);
k=1;
for i=1:M-2
    if ((z(i+1)>z(i)) && (z(i+2)<z(i+1)))
        mt(k)=t(i+1);
        mx(k)=z(i+1);
        k=k+1;
    end;
end;
figure(4)
for i=1:size(mx,2)-1
    plot(mx(i),mx(i+1),'ro','MarkerEdgeColor','r',...
                'MarkerFaceColor','g',...
                'MarkerSize',5);
           axis([min(mx)-1 max(mx)+1 min(mx)-1 max(mx)+1])
    hold on
end;
xlabel('z_n','FontName','Times New Roman','FontSize',16)
ylabel('z_{n+1}','FontName','Times New Roman','FontSize',16)
%------------
% figure(5)
% plot3(R1(:,2),R1(:,3),R1(:,4),'b')
% hold on
% plot3(R2(:,2),R2(:,3),R2(:,4),'r')
% view([6.0 14.0])




